#!/usr/bin/env python3

import json
import os
import urllib
import http.client
import urllib.parse
import signal
import sys
import time
import datetime
import socket
from pathlib import Path
from http.server import HTTPServer, BaseHTTPRequestHandler
from telemetery_api_client import subscibe_listener
import json
import threading
from queue import Queue
from telemetry_dispatcher import dispatch_telmetery
from telemetry_http_listener import start_http_listener

class PostHandler(BaseHTTPRequestHandler):
    def do_POST(self):
        self.send_response(200)
        data = "This is a python http function"
        self.send_header('Content-type', 'application/json')
        self.send_header('isBase64Encoded', 'false')
        self.end_headers()
        self.wfile.write(json.dumps(data).encode())

host = ('localhost', 8010)

def handle_signal(signal, frame):
    sys.exit(0)

def register_extension():
    queue = Queue()
    listener_url = start_http_listener(queue)
    dispatch_telmetery(queue, True)
    headers = {
        'Content-type': 'application/json',
        'FunctionGraph-Extension-Name': "extension_1.sh",
        'FunctionGraph-Extension-Address': "127.0.0.1:8010"
    }
    payload = {}
    json_data = json.dumps(payload)
    url1 = os.getenv("EXTENSION_API_ADDR")
    str = url1.split(':')
    address = str[0]
    port = str[1]

    url2=f"/extension/register"
    con = http.client.HTTPConnection(address, port)
    con.request("POST", url2, json_data, headers)

    print("[Extension] register extension", flush=True)
    subscibe_listener()


def main():
    # handle signals
    signal.signal(signal.SIGINT, handle_signal)
    signal.signal(signal.SIGTERM, handle_signal)

    server = HTTPServer(host, PostHandler)
    server_thread = threading.Thread(target=server.serve_forever)
    # Exit the server thread when the main thread terminates
    server_thread.daemon = True
    server_thread.start()
    
    # execute extensions logic
    register_extension()
    while True:
        time.sleep(1)

if __name__ == "__main__":
    main()

